<script setup lang="ts">
import { onMounted, ref } from 'vue'


import { useStockStore } from '@/stores/stock'
import { useStockDetailStore } from '@/stores/stockDetail'
import { useUserStore } from '@/stores/user'
import { useBranchStore } from '@/stores/branch'
import { useMaterialStore } from '@/stores/material'

import { type Stock } from '@/types/Stock'
import type { StockDetail } from '@/types/StockDetail'

import AddStockAllDialogVue from '@/components/Stock/AddStockAllDialog.vue'
import deleteStockDialogVue from '@/components/Stock/deleteDialog.vue'
import AddStockSomeDialogVue from '@/components/Stock/AddStockSomeDialog.vue'

const stockStore = useStockStore()
const stockDetailStore = useStockDetailStore()
const userStore = useUserStore()
const branchStore = useBranchStore()
const materialStore = useMaterialStore()

const stockheaders = [
  {
    title: 'รหัสของสต็อก',
    key: 'id',
    value: 'id',
    width: '300px'
  },
  {
    title: 'วันและเวลา(วัน-เดือน-ปี)',
    key: 'date',
    value: 'date',
    width: '500px'
  },
  {
    title: 'ผู้เช็ค',
    key: 'user id',
    value: 'user id',
    width: '150px'
  },
  {
    title: 'สาขา',
    key: 'branch id',
    value: 'branch id',
    width: '100px'
  }
]

const stockDetailsheaders = [
  {
    title: 'รหัสของรายละเอียดในสต็อก',
    key: 'id',
    value: 'id',
    width: '500px'
  },
  {
    title: 'ชื่อวัตถุดิบ',
    key: 'material id',
    value: 'material id',
    width: '200px'
  },
  {
    title: 'ปริมาณ',
    key: 'QOH',
    value: 'QOH',
    width: '50px'
  },
  {
    title: 'หน่วย',
    key: 'unit',
    value: 'unit',
    width: '100px'
  },
  {
    title: 'ส่วนต่างจากจำนวนต่ำสุด',
    key: 'balance',
    value: 'balance',
    width: '500px'
  }
]

const editedStock = ref<Stock>()
const refByStockId = ref<number>()

const send = (item: Stock) => {
  console.log('stocks: ', stockStore.stocks)
  editedStock.value = JSON.parse(JSON.stringify(item))
  if (editedStock.value) {
    refByStockId.value = editedStock.value.id
    getdetailByStockId(refByStockId.value)
    console.log('details: ', stockDetailStore.stockDetails)
  }
}

function getdetailByStockId(stockId: number) {
  stockDetailStore.getStockDetailsByStockId(stockId)
}

function addDialog(add: string) {
  console.log('add', add)
  if (add === 'ADD STOCK BY All MATERIAL') stockStore.addAllDialog = true
  else {
    stockStore.addSomeDialog = true
  }
}

onMounted(() => {
  stockStore.getStocks()
  userStore.getUsers()
  branchStore.getBranches()
  materialStore.getMaterials()
})

const items = ['ADD STOCK BY All MATERIAL', 'ADD STOCK BY SOME MATERIAL']
function printPDF() {
  const path = 'public/pdf/checkstockbill/checkstockbill.pdf';
  // เปิด PDF ในหน้าต่างใหม่
  window.open(path);
}
</script>

<template>
  <v-sheet>
    <v-row>
      <!-- First Table -->
      <v-col cols="5">
        <v-card variant="outlined" color="primary">
          <v-toolbar class="custom-stock-toolbar">
            <v-toolbar-title style="font-size: 24px; color: #5865f2"> Stocks </v-toolbar-title>
            <v-spacer></v-spacer>
            <v-menu>

              <template v-slot:activator="{ props }">
                <v-btn style="background-color: #5865f2; color: white" @click="printPDF()">
                  Print Bill
                </v-btn>
                <v-spacer></v-spacer>
                <v-btn style="background-color: #5865f2; color: white" v-bind="props">
                  ADD STOCK
                </v-btn>
              </template>
              <v-list>
                <v-list-item v-for="(item, index) in items" :key="index" :value="index">
                  <v-list-item-title @click="addDialog(item)">{{ item }}</v-list-item-title>
                </v-list-item>
              </v-list>
            </v-menu>
          </v-toolbar>
          <v-data-table :items="stockStore.stocks" :headers="stockheaders" class="elevation-1 custom-table" fixed-header
            height="350px">
            <template v-slot:item="props">
              <tr>
                <td @click="send(props.item)">{{ props.item.id }}</td>
                <td @click="send(props.item)">{{ props.item.date }}</td>
                <td @click="send(props.item)">{{ stockStore.getUserName(props.item.userID) }}</td>
                <td @click="send(props.item)">
                  {{ stockStore.getBranchName(props.item.branchID) }}
                </td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>

      <!-- Second Table -->
      <v-col cols="7">
        <v-card variant="outlined" color="primary">
          <v-toolbar class="custom-stock-detail-toolbar">
            <v-toolbar-title style="font-size: 24px; color: #5865f2">
              Stock Details
            </v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
          <v-data-table :items="stockDetailStore.stockDetails" :headers="stockDetailsheaders"
            class="elevation-1 custom-table" fixed-header height="350px">
            <template v-slot:item="props">
              <tr>
                <td>{{ props.item.id }}</td>
                <td>{{ stockDetailStore.getMaterialName(props.item.materialId) }}</td>
                <td>{{ props.item.QOH }}</td>
                <td>{{ stockDetailStore.getMaterialType(props.item.materialId) }}</td>
                <td>{{ props.item.balance }}</td>
              </tr>
            </template>
          </v-data-table>
        </v-card>
      </v-col>
    </v-row>
  </v-sheet>

  <AddStockAllDialogVue></AddStockAllDialogVue>
  <AddStockSomeDialogVue></AddStockSomeDialogVue>
  <deleteStockDialogVue></deleteStockDialogVue>
</template>

<style scoped>
.custom-stock-toolbar {
  background-image: url('../image/stock/warehourse.jpg');
  background-size: cover;
  background-position: center;
  color: white;
  /* เพิ่มสีตัวอักษรหรือสีขอบอื่น ๆ ตามที่ต้องการ */
}

.custom-stock-detail-toolbar {
  background-image: url('../image/stock/warehourse.jpg');
  background-size: cover;
  background-position: center;
  color: white;
  /* เพิ่มสีตัวอักษรหรือสีขอบอื่น ๆ ตามที่ต้องการ */
}
</style>
